
#include "lg/interface.h"
#include "lg/scrservices.h"
#include "ScriptLib.h"
#include "GenericScale.h"

long cScrScale::OnTurnOn(sScrMsg* pMsg, sMultiParm* pReply)
{
	float fScale = 0;
	char* pszScale = GetObjectParamString(m_iObjId, "on");
	if (!pszScale)
		pszScale = GetObjectParams(m_iObjId);
	if (!pszScale)
		return 1;
	fScale = strtod(pszScale, NULL);
	g_pMalloc->Free(pszScale);
	long iRet = 1;
	iRet = OnScale(fScale, pMsg, pReply);
	if (pReply)
		MultiParmAssignInt(pReply, (iRet) ? 0 : 1);
	return iRet;
}

long cScrScale::OnTurnOff(sScrMsg* pMsg, sMultiParm* pReply)
{
	float fScale = 0;
	char* pszScale = GetObjectParamString(m_iObjId, "off");
	if (pszScale)
	{
		fScale = strtod(pszScale, NULL);
		g_pMalloc->Free(pszScale);
	}
	else
	{
		pszScale = GetObjectParams(m_iObjId);
		if (!pszScale)
			return 1;
		fScale = -strtod(pszScale, NULL);
		g_pMalloc->Free(pszScale);
	}
	long iRet = 1;
	iRet = OnScale(fScale, pMsg, pReply);
	if (pReply)
		MultiParmAssignInt(pReply, (iRet) ? 0 : 1);
	return iRet;
}

long cScrScale::OnControl(sScrMsg* pMsg, sMultiParm* pReply)
{
	float fScale;
	long iRet;
	switch (pMsg->data.type)
	{
	case kMT_Int:
		fScale = pMsg->data.i;
		break;
	case kMT_Float:
		fScale = pMsg->data.f;
		break;
	case kMT_String:
		if (pMsg->data.psz)
		{
			char* pszEnd;
			fScale = strtod(pMsg->data.psz, &pszEnd);
			if (pszEnd && *pszEnd == '\0')
				break;
		}
	default:
		return 1;
	}
	iRet = OnScale(fScale, pMsg, pReply);
	return iRet;
}

